# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 12
# Ενότητα 12.4.4 Αλγόριθμος Αρχιμήδη

import decimal, math, timeit

def pi():
    c=1
    a=4*math.sqrt(3)
    b=6
    while True:
        p=(a+b)/4
        if math.isclose(p, math.pi): return (c,p)
        c+=1
        a=2*a*b/(a+b)
        b=math.sqrt(a*b)

print(pi())
print(timeit.timeit(stmt="pi()", number=1, globals=globals()))


# Υλοποίηση με decimal

def pi(n):
    decimal.getcontext().prec = n+3
    a=4*decimal.Decimal(3).sqrt()
    b=decimal.Decimal(6)
    c=1
    while a!=b:
        c+=1
        a=2*a*b/(a+b)
        b=(a*b).sqrt()
    p=a/2
    decimal.getcontext().prec = n
    return (c,+p)

print(pi(100))
print(pi(770))
print(timeit.timeit(stmt="pi(770)", number=1, globals=globals()))
print(timeit.timeit(stmt="pi(5000)", number=1, globals=globals()))
