# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 12
# Ενότητα 12.4.5 Αλγόριθμος Viète

import decimal, math, timeit

def pi():
    r=c=1
    a=math.sqrt(2)
    while True:
        r*=a/2
        p=2/r
        if math.isclose(p,math.pi): break
        c+=1
        a=math.sqrt(2+a)
    return (c,p)

print(pi())


# Υλοποίηση με decimal

def pi(n):
    decimal.getcontext().prec = n+3
    r=decimal.Decimal(1)
    c=1
    a=decimal.Decimal(2).sqrt()
    pr=0
    while True:
        r*=a/2
        if r==pr: break
        pr=r
        c+=1
        a=(2+a).sqrt()
    p=2/r
    decimal.getcontext().prec = n
    return (c,+p)

print(pi(770))
print(timeit.timeit(stmt="pi(770)", number=1, globals=globals()))
print(timeit.timeit(stmt="pi(5000)", number=1, globals=globals()))
