# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 12
# Ενότητα 12.4.6 Αλγόριθμος Newton-Euler

import decimal, math, timeit

def pi():
    k=0
    sum=0
    while True:
        term=((2**k)*(math.factorial(k))**2)/math.factorial(2*k+1)
        sum+=term
        p=2*sum
        k+=1
        if math.isclose(p, math.pi): return (k, p)

print(pi())
print(timeit.timeit(stmt="pi()", number=1, globals=globals()))


# Υλοποίηση με decimal

def pi(n):
    decimal.getcontext().prec = n+3
    k=decimal.Decimal(0)
    sum=decimal.Decimal(0)
    pp=0
    while True:
        term=((2**k)*(math.factorial(k))**2)/math.factorial(2*k+1)
        sum+=term
        p=2*sum
        k+=1
        if p==pp: break
        pp=p
    decimal.getcontext().prec = n
    return (k,+p)

print(pi(770))
print(timeit.timeit(stmt="pi(770)", number=1, globals=globals()))


# Αποδοτική υλοποίηση με decimal

def pi(n):
    decimal.getcontext().prec = n+3
    k=decimal.Decimal(0)
    sum=decimal.Decimal(0)
    pp=0
    f1=decimal.Decimal(1)
    f2=decimal.Decimal(1)
    f3=decimal.Decimal(1)
    f4=decimal.Decimal(2)
    while True:
        term = f1*f2/f3
        sum+=term
        p=2*sum
        k+=1
        if p==pp: break
        pp=p
        f1*=2
        f2*=k*k
        f3*=f4*(f4+1)
        f4+=2
    decimal.getcontext().prec = n
    return (k,+p)

print(timeit.timeit(stmt="pi(770)", number=1, globals=globals()))
print(timeit.timeit(stmt="pi(5000)", number=1, globals=globals()))
