# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 12
# Ενότητα 12.4.7 Αλγόριθμος Bailey–Borwein–Plouffe (BBP)

import decimal, math, timeit

def pi():
    k=0
    p=0
    while True:
        term = 4/(8*k+1)-2/(8*k+4)-1/(8*k+5)-1/(8*k+6)
        term = term/(16**k)
        p+=term
        k+=1
        if math.isclose(p, math.pi): return (k, p)

print(pi())
print(timeit.timeit(stmt="pi()", number=1, globals=globals()))


# Υλοποίηση με decimal

def pi(n):
    decimal.getcontext().prec = n+3
    k8=decimal.Decimal(0)
    p=decimal.Decimal(0)
    f=1
    pp=1
    while True:
        term = 4/(k8+1)-2/(k8+4)-1/(k8+5)-1/(k8+6)
        term = term/f
        p+=term
        k8+=8
        if p==pp: break
        pp=p
        f*=16
    decimal.getcontext().prec = n
    return (k8/8,+p)

print(pi(770))
print(timeit.timeit(stmt="pi(770)", number=1, globals=globals()))
print(timeit.timeit(stmt="pi(5000)", number=1, globals=globals()))
