# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 10 - Παράδειγμα 10. επιλογή φύλλων από sprite (ενότητα 10,12 εικόνες)

import tkinter as tk
import tkinter.messagebox as ms

class App()  :
    def __init__(self, root):
        self.root = root
        root.title("ex.10. cards")
        root.geometry("150x200+300+300")
        root.resizable(False,False)
        self.create_widgets()
    def create_widgets(self):
        self.f1 = tk.Frame(self.root, bg='green')
        self.f1.pack(fill='both', expand=1)
        self.f2 = tk.Frame(self.root, bg='green')
        self.f2.pack(fill='both', expand=1)
        self.requested_card = tk.StringVar()
        self.requested_card.set( "")
        self.l = tk.Label(self.f1, text = "Δώσε κάρτα :", bg='#efefef', font='Arial 14')
        self.l.pack(side='left', fill='both')
        self.e = tk.Entry(self.f1, textvariable=self.requested_card, fg='grey', font='Arial 14').pack()
        self.canvas = tk.Canvas(self.f2, bg='green')
        self.canvas.pack(side='left', fill = 'both')
        self.root.bind('<Return>', self.select_image)
        self.generate_images_from_sprite()
    def generate_images_from_sprite(self):
        self.spritesheet = tk.PhotoImage(file= "cards2.gif")
        self.num_sprites = 13
        self.cards = []
        place = 0
        self.images = {}
        for x in 'sdhc':
            self.images [x] = [self.subimage(79*i, 0+place, 79*(i+1), 123+place) for i in range(self.num_sprites)]
            place += 123
    def select_image(self, event):
        card = self.requested_card.get()
        self.cards = card.split(",")
        error = False
        for card in self.cards:
            card = card.strip()
            if card[1].lower() in "scdh" and card[0].upper() in "A23456789TJQK": self.drawimage((30,20), card)
            else: error = True
        if error:
            ms.showinfo("Προσοχή",  "Λίστα από κάρτες με τιμή-σύμβολο, τιμές A,2-9,T,J,Q,K και σύμβολα s,d,h,c")
        self.requested_card.set("")
    def subimage(self, l, t, r, b):
        dst = tk.PhotoImage()
        dst.tk.call(dst, 'copy', self.spritesheet, '-from', l, t, r, b, '-to', 0, 0)
        return dst
    def drawimage(self, pos, card):
        print ("drawimage", pos, card)
        sprite = 'A23456789TJQK'.find(card[0].upper())
        symbol = card[1].lower()
        self.new_img = self.canvas.create_image(*pos, image=self.images[symbol][sprite], anchor = 'nw')
        return self.new_img
#-------------------------------------
def main():
    root = tk.Tk()
    App(root)
    root.mainloop()
main()
