# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 14 - Λειτουργικά Συστήματα
#example 14_1/ Λειτουργικά Συστήματα/ version 1.1 / Dec.2016
import os # βιβλιοθήκη σύνδεσης στο λειτουργικό σύστημα
import psutil # βιβλιοθήκη με εργαλεία για διεργασίες και παραμετρους του συστήματος,
#  ανεξάρτητη λειτουργικού
# η βιβλιοθήκη psutil δεν είναι στην διανομή της Python πρέπει να φορτωθεί (πχ pip3 install psutil)
import time # βιβλιοθήκη μέτρησης χρόνου

def get_host_cpu_stats():
    # στοιχεία του επεξεργαστή
##    print(psutil.cpu_times())
##    input()
    return {
        'kernel': int(psutil.cpu_times()[2]),
        'idle': int(psutil.cpu_times()[3]),
        'user': int(psutil.cpu_times()[0]),
    }

def get_stats():
    profile = dict(
        vm_cpu=psutil.cpu_percent(),
        vm_mem=psutil.virtual_memory(),  
    )
    return profile

#### Παραδείγματα ενότητας 13.5

print("Λειτουργικό Σύστημα")
print(os.name)
import platform
print(platform.platform())
# Στοιχεία ΚΜΕ
print('\nΑριθμός πυρήνων ΚΜΕ  = ', psutil.cpu_count())
print(get_host_cpu_stats())
print(get_stats())
# Μνήμη
mem = psutil.virtual_memory().total/1024**3
print('Φυσική Μνήμη = %.2f Gbytes' % mem)
# Αριθμός πυρήνων
print('Αριθμός CPUs=', psutil.cpu_count())
# Δευτερεύσα μνήμη
print("\nΜονάδες δίσκων")
dp = psutil.disk_partitions()
for p in dp:
    print(p[0], "mount: ", p[1])
print()
Gib = 1024**3
d_io = psutil.disk_io_counters(perdisk=True)
print("Δίσκος\tΑναγν.\tΕγγραφ.\tΑν.Gb\tΕγ.Gb")
for d in d_io:
    if 'sd' in d:
        r_count = d_io[d].read_count
        w_count = d_io[d].write_count
        r_gb = d_io[d].read_bytes/Gib
        w_gb = d_io[d].write_bytes/Gib
        print('%s : \t%d\t%d\t%.2f\t%.2f' % (d, r_count, w_count,
                r_gb, w_gb))
### network
net = psutil.net_io_counters()
print ("\nΔικτύωση: Download: {:.2f} GB, Upload: {:.2f} GB".format(net[1]/Gib, net[0]/Gib))
### πόσο χρόνο είναι ενεργός ο υπολογιστής
t1 = time.time()
t2 = psutil.boot_time()
seconds = int(t1-t2)
m, s = divmod(seconds, 60)
h, m = divmod(m, 60)
d, h = divmod(h, 24)
print ('\nΟ υπολογιστής είναι σε λειτουργία = %d μέρες και %d ώρες %02d min %02d sec' % (d, h, m, s))

