# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 15 - Μόνιμη αποθήκευση δεδομένων
# εφαρμογή university - έκδοση 4 (sqlite3)
import sqlite3 as lite
import os.path

class Main():
    def __init__(self):
        while True:
            print("0. Μέση βαθμολογία φοιτητών\n1. Καρτέλα φοιτητή\n2. Βαθμολόγιο μαθήματος\n3. Στατιστικά Μαθημάτων\n<enter: exit>\n")
            sel = input()
            if not sel: break
            if sel == "0":
                sql = '''select student.am, student.surname, student.name, avg(enroll.grade)
                            from student, enroll
                            where student.am = enroll.am
                            group by enroll.am
                            order by surname;'''
                stud_list = self.query_db(sql)
                for s in stud_list:
                    print("{}\t{:15s}\t{:15s}\t{:.1f}".format(*s))
                print()
            if sel == "1":
                sql = "select student.am from student;"
                result = self.query_db(sql)
                if result:
                    student_am = [x[0] for x in result]
                    selected = input("Κωδικός φοιτητή  ... 101-{}...".format(100+len(student_am)))
                    if selected in student_am:
                        sql = '''select student.surname, student.name
                                    from student
                                    where student.am = {};'''.format(selected)
                        s = self.query_db(sql)
                        print(s)
                        for st in s:
                            print("[{}]\t{:15s}\t{:15s}".format(selected, *st))
                        print(50*"_")
                        sql = '''select course.id, course.name, enroll.grade
                                    from course, enroll, student
                                    where enroll.id = course.id and student.am = enroll.am and student.am={}
                                    order by course.id;'''.format(selected)
                        courses = self.query_db(sql)
                        if courses:
                            grades = []
                            for c in courses:
                                print("[{}]\t{:25s}\t{:.2f}".format(*c))
                                grades.append(int(c[2]))
                            print("Μέση βαθμολογία = {:.2f}\n".format(sum(grades)/len(grades)))
                            print(50 * "_")
            if sel == "2":
                courses_id = [x[0] for x in self.query_db("select course.id from course;")]
                s = input("Μάθημα: (επιλογές {}) ...".format(",".join(courses_id)))
                try:
                    course = self.query_db("select * from course where course.id={};".format(s))
                    if course:
                        print("\n[{}]  : {}".format(*course[0]))
                        print(50 * "_")
                    sql='''select student.am, student.surname, student.name, enroll.grade
                                from course, enroll, student
                                where enroll.id = course.id and student.am = enroll.am and enroll.id={}
                                order by student.surname;'''.format(s)
                    for stud in self.query_db(sql):
                        print("{}\t{:15s}\t{:10s}\t{:.2f}".format(*stud))
                    print(50 * "_")
                except: print('όχι σωστός κωδικός')
            if sel == "3":
                sql = '''select course.id, course.name, avg(enroll.grade), count(enroll.grade)
                            from course, enroll
                            where enroll.id = course.id 
                            group by course.id
                            order by course.id;'''
                for c in self.query_db(sql):
                    print("{}\t{:30s}\t{:.2f} ({} φοιτ.)".format(*c))
                print(50 * "_")

    def query_db(self, sql):
        db_name = "university.db"
        try:
            conn = lite.connect(os.path.join(".", db_name))
            with conn:
                curs = conn.cursor()
                curs.execute(sql)
                return curs.fetchall()
        except lite.Error as er:
            print(er)
            return 0

if __name__ == "__main__": Main()
