# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 15 - Μόνιμη αποθήκευση δεδομένων
# εφαρμογή university - έκδοση 5 (mongoDB)
import pymongo
import json
import os.path

class Main():
    def __init__(self):
        self.create_db()
        while True:
            print("0. Μέση βαθμολογία φοιτητών\n1. Καρτέλα φοιτητή\n2. Βαθμολόγιο μαθήματος\n3. Στατιστικά Μαθημάτων\n<enter: exit>\n")
            sel = input()
            if not sel: break
            if sel == "0":
                with pymongo.MongoClient() as con:
                    db = con.university
                    students = db.students.find({}).limit(0)
                    for s in sorted(students, key= lambda x: x.get("surname")):
                        avg = sum(s["courses"].values()) / len(s["courses"])
                        print("{}\t{:15s}\t{:15s}\t{:.1f}".format(s["_id"], s["surname"], s["name"], avg))
                    print()
            if sel == "1":
                with pymongo.MongoClient() as con:
                    db = con.university
                    no_stud = db.students.count()
                    selected = input("Κωδικός φοιτητή  ... 101-{}...".format(100 + no_stud))
                    # αναζήτηση στοιχείων φοιτητή
                    the_student = db.students.find({"_id":selected},{"surname":1, "name":1, "courses":1})
                    for s in the_student:
                        print("[{}]\t{:15s}\t{:15s}".format(s["_id"], s["surname"], s["name"]))
                        print("_________________")
                        for k,v in s.get("courses").items():
                            the_course = db.courses.find({"_id":k}) # αναζήτηση στοιχείων μαθήματος
                            for c in the_course: course_name = c["name"]
                            print("[{}]\t{:25s}\t{:.2f}".format(k, course_name, v))
                        print("Μέση βαθμολογία = {:.2f}\n".format(sum(s.get("courses").values()) /
                                                                  len(s.get("courses"))))
            if sel == "2":
                with pymongo.MongoClient() as con:
                    course_name = ""
                    db = con.university
                    courses =  [x["_id"]+": "+x["name"] for x in db.courses.find({},{"_id":1, "name":1})]
                    print("\n".join(courses))
                    sel = input("Μάθημα: ")
                    the_course = db.courses.find({"_id": sel})  # αναζήτηση στοιχείων μαθήματος
                    for c in the_course: course_name = c.get("name")
                    if course_name:
                        print("{} :  {}\n_________________".format(sel, course_name))
                        stud = db.students.find({"courses.{}".format(sel): {"$exists": 1}})
                        grades = []
                        for s in stud:
                            g = s.get("courses").get(sel)
                            grades.append(g)
                            print("{}\t{:15s}\t{:10s}\t{:.2f}".format(s["_id"], s["surname"], s["name"], g))
                        print("_________________")
                        if grades: print("Μέση βαθμολογία: {}\n".format(sum(grades)/len(grades)))

            if sel == "3":
                with pymongo.MongoClient() as con:
                    course_name = ""
                    db = con.university
                    courses = [(x["_id"],x["name"]) for x in db.courses.find({}, {"_id": 1, "name": 1})]
                    grades = []
                    for c in courses:
                        co = "courses.{}".format(c[0])
                        stud = [x.get("courses").get(c[0]) for x in db.students.find({co: {"$exists": 1}},{"_id":0,co:1})]
                        if stud:
                            s, st = sum(stud), len(stud)
                            grades.append((s,st))
                            print("{}\t{:30s}\t{:.2f} ({} φοιτ.)".format(c[0], c[1], s/st, st))
                    print("_________________")
                    if grades: print("Μέση βαθμολογία: {:.2f}\n".format(sum([x[0] for x in grades]) /
                                                                        sum([x[1] for x in grades])))
                    print("_________________")
    #

    def create_db(self):
        with pymongo.MongoClient() as con:
            db = con.university
            if not db.courses.count() and not db.students.count():
                db.courses.remove()
                db.courses.remove()
                dir = "."
                for f in ['courses', 'students']:
                    try:
                        with open(os.path.join(dir, f+".json")) as j:
                            dic = json.load(j)
                            for id in dic:
                                record = {'_id':id}
                                for x in dic[id]:
                                    record[x] = dic.get(id).get(x)
                                db[f].insert(record)
                    except: print("no data inserted")

if __name__ == "__main__": Main()
