# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 18 - Διαδικτυακές εφαρμογές
# Ενότητα 18.4 Ανάκτηση από την σελίδα eudoxus.gr
from bs4 import BeautifulSoup
import urllib.request
import urllib.error
import datetime

def search_for_unis(url1):
    unis = []
    #this will look for all universities found in url1
    try:
        with urllib.request.urlopen(url1) as response:
            html  = response.read()
        soup = BeautifulSoup(html, "lxml")
        for tag in soup.find_all():
            if tag.name == 'h2':
                uni_name = tag.get_text()
                if uni_name not in unis and uni_name not in ['Λίστα Ιδρυμάτων και Τμημάτων', 'Περιεχόμενα']:
                    unis.append(uni_name)
        return unis
    except: urllib.error.URLError : print("not connected")

def search_for_departments(url, university, YEAR):
    print(university)
    # search for the departments of uni in page url
    try:
        with urllib.request.urlopen(url) as response:
            h  = response.read()
        soup = BeautifulSoup(h, "lxml")
        # search for university in list
        uni=False
        depts={}
        acad_year = str(int(YEAR)-1)  + " - " + str(YEAR)
        print ("Academic year = ", acad_year)
        for tag in soup.find_all():
            if tag.name == 'h2':
                if university in tag.get_text() :
                    uni = True
                else:
                    uni = False
            if uni:
                if tag.name == 'p':
                    department = tag.get_text()
                    if department not in depts.keys():
                        depts[department] = ""
                if tag.name == 'a' :
                    if acad_year in tag.get_text() :
                        url2 = tag['href']
                        url2= "https://service.eudoxus.gr"+url2
                        depts[department] = url2
        return depts
    except: urllib.error.URLError: print("not connected")

def main():
    url1 = 'https://service.eudoxus.gr/public/departments'
    YEAR = datetime.datetime.now().year
    while True:
        user = input("Ακαδημαϊκό έτος (enter για {}-{}):".format(YEAR-1, YEAR))
        if not user: break
        if user.strip().isdigit() and 2010 < int(user) <= YEAR+1:
            YEAR = int(user)
            break
    print("ανάκτηση πληροφορίας ...")
    u = search_for_unis(url1)
    if u:
        for uni in u:
            d = search_for_departments(url1, uni, YEAR)
            if d:
                for dept in d:
                    print("...", dept, d[dept])
                x = input("x for exit")
                if x == "x":
                    break

if __name__ == '__main__':
    main()
